<?php
/* vim: set expandtab tabstop=4 softtabstop=4 shiftwidth=4:
  Codificación: UTF-8
  +----------------------------------------------------------------------+
  | Elastix version 2.4.0-1                                              |
  | http://www.elastix.org                                               |
  +----------------------------------------------------------------------+
  | Copyright (c) 2006 Palosanto Solutions S. A.                         |
  +----------------------------------------------------------------------+
  | Cdla. Nueva Kennedy Calle E 222 y 9na. Este                          |
  | Telfs. 2283-268, 2294-440, 2284-356                                  |
  | Guayaquil - Ecuador                                                  |
  | http://www.palosanto.com                                             |
  +----------------------------------------------------------------------+
  | The contents of this file are subject to the General Public License  |
  | (GPL) Version 2 (the "License"); you may not use this file except in |
  | compliance with the License. You may obtain a copy of the License at |
  | http://www.opensource.org/licenses/gpl-license.php                   |
  |                                                                      |
  | Software distributed under the License is distributed on an "AS IS"  |
  | basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See  |
  | the License for the specific language governing rights and           |
  | limitations under the License.                                       |
  +----------------------------------------------------------------------+
  | The Original Code is: Elastix Open Source.                           |
  | The Initial Developer of the Original Code is PaloSanto Solutions    |
  +----------------------------------------------------------------------+
  $Id: index.php,v 1.1 2013-06-10 07:10:30 Nikita Rukavkov admin@voip-lab.ru Exp $ */

function _moduleContent(&$smarty, $module_name)
{

    foreach($_POST as $key=>$val){
        $val = preg_replace("/<.*?>/","",$val);
        $_POST[$key] = $val;
    }

    include_once "libs/paloSantoForm.class.php";
    include_once "libs/paloSantoGrid.class.php";
    include_once "libs/paloSantoConfig.class.php";
    
    include_once "modules/$module_name/configs/default.conf.php";
    include_once "modules/$module_name/libs/paloSantoFail2Ban.class.php";
    
    global $arrConf;
    global $arrLang;
    global $arrLangModule;
    
    
    $lang=get_language();
    $lang_file="modules/$module_name/lang/$lang.lang";
    $lic_file="modules/$module_name/configs/anti-hacker.lic";
    
    $base_dir=dirname($_SERVER['SCRIPT_FILENAME']); 
    
    if (file_exists("$base_dir/$lang_file")) include_once "$lang_file";
    else include_once "modules/$module_name/lang/en.lang";    
    

    
    $paloFail2Ban = new PaloSantoFail2Ban();    
    
    $arrLang = array_merge($arrLang,$arrLangModule);
    
    $base_dir=dirname($_SERVER['SCRIPT_FILENAME']);
    $templates_dir=(isset($arrConfig['templates_dir']))?$arrConfig['templates_dir']:'themes';
    $local_templates_dir="$base_dir/modules/$module_name/".$templates_dir.'/'.$arrConf['theme'];

    $arrNetTools = array("target"   => array(   "LABEL"                     => $arrLang["Email for report"],
                                                "REQUIRED"                  => "yes",
                                                "INPUT_TYPE"                => "TEXT",
                                                "VALIDATION_TYPE"           => "email",
						"INPUT_EXTRA_PARAM"	    => "",
                                                "VALIDATION_EXTRA_PARAM"    => ""),
                         "count"    => array(   "LABEL"                     => $arrLang["Count error registrations"],
                                                "REQUIRED"                  => "yes",
                                                "INPUT_TYPE"                => "TEXT",
						"INPUT_EXTRA_PARAM"	    => "",
                                                "VALIDATION_TYPE"           => "numeric",
                                                "VALIDATION_EXTRA_PARAM"    => ""),
                         "bantime"    => array( "LABEL"                    => $arrLang["Ban time"],
                                                "REQUIRED"                  => "yes",
                                                "INPUT_TYPE"                => "TEXT",
						"INPUT_EXTRA_PARAM"	    => "",
                                                "VALIDATION_TYPE"           => "numeric",
                                                "VALIDATION_EXTRA_PARAM"    => ""),
                    	 "exceptions"    => array( "LABEL"                    => $arrLang["Exceptions"],
                                                "REQUIRED"                  => "no",
                                                "INPUT_TYPE"                => "TEXT",
						"INPUT_EXTRA_PARAM"	    => "",
                                                "VALIDATION_TYPE"           => "",
                                                "VALIDATION_EXTRA_PARAM"    => ""),
                         "exceptions_help"   => array( "LABEL"                    => $arrLang["Exceptions help"],
                                                "REQUIRED"                  => "no",
                                                "INPUT_TYPE"                => "TEXT",
						"INPUT_EXTRA_PARAM"	    => "",
                                                "VALIDATION_TYPE"           => "",
                                                "VALIDATION_EXTRA_PARAM"    => ""),
                         "lic_file"              => array( "LABEL" => $arrLang["License file"],
                        			"REQUIRED" => "no",
                        			"INPUT_TYPE" => "FILE",
                        			"INPUT_EXTRA_PARAM" => " ",
                        			"VALIDATION_TYPE" => "filename",
                        			"VALIDATION_EXTRA_PARAM" => ""),
                                                );                        


    
    $oForm = new paloForm($smarty, $arrNetTools);

    $filter_Jail = getParameter('filter_jail');
    $filter_IP = getParameter('filter_ip');

    $smarty->assign("Filter", $arrLang["Filter"]);
    $arrFormElements = createFilterForm($arrLang);
    $oFilterForm = new paloForm($smarty,$arrFormElements);

    if(getParameter("update")) {
        $arrValues = array();
        foreach(array('target', 'count', 'bantime','websecure','asterisksecure','sshsecure','vsftpdsecure','exceptions') as $v) 
	    if(isset($_POST[$v])) {
	        $space_filter = str_replace(' ','',$_POST[$v]);
	        $space_filter = preg_replace('/\s/', '', $space_filter);
	        $arrValues[$v] = $space_filter;
	        $$v = $space_filter;
	    }
	
        $arrValues['websecure']=(isset($arrValues['websecure']) ? 'on'  : 'off');
	$arrValues['asterisksecure']=(isset($arrValues['asterisksecure']) ? 'on'  : 'off');
	$arrValues['sshsecure']=(isset($arrValues['sshsecure']) ? 'on'  : 'off');
	$arrValues['vsftpdsecure']=(isset($arrValues['vsftpdsecure']) ? 'on'  : 'off');

        if($_FILES["lic_file"]["error"]<=0)
        {
	    if (move_uploaded_file($_FILES['lic_file']['tmp_name'], $lic_file)) {
		$smarty->assign("mb_title", $arrLang["License file"]);
		$smarty->assign("mb_message", "License file successfully uploaded");
	    }
	    else
	    {
		$smarty->assign("mb_title", $arrLang["License file"]);
		$smarty->assign("mb_message", "Error file upload license. please contact support.");
	    }
	}

	if(!$oForm->validateForm($_POST)){
	    $smarty->assign("mb_title", _tr("Validation Error"));
	    $arrErrores = $oForm->arrErroresValidacion;
	    $strErrorMsg = "<b>"._tr("The following fields contain errors").":</b><br/>";
	    if(is_array($arrErrores) && count($arrErrores) > 0){
		foreach($arrErrores as $k=>$v)
		    $strErrorMsg .= "$k, ";
	    }
	    $smarty->assign("mb_message", $strErrorMsg);
	} 
  
	else{
	    if(!$paloFail2Ban->updateFileConfFail2Ban($arrValues))
	    {
		 $smarty->assign("mb_title", $arrLang["Save settings error"].":");
		 $smarty->assign("mb_message", $paloFail2Ban->errMsg);
	    }
	}
    }
    
    if(getParameter('stop')) {
	   if(!$paloFail2Ban->stopServiceFail2Ban())
	   {
	    	$smarty->assign("mb_title", $arrLang["Stop Error"]);
    		$smarty->assign("mb_message", $paloFail2Ban->errMsg);
	   }

    }
    if(getParameter('start')) {
	   if(!$paloFail2Ban->startServiceFail2Ban())
	   {
	    	$smarty->assign("mb_title", $arrLang["Start Error"]);
    		$smarty->assign("mb_message", $arrLang["Save settings, please"]);
	   }
	   
    }
    if(getParameter('submit_eliminar')=='Unban IP')
    {
	   $paloFail2Ban->removeFromIptables(getParameter('ip'));
    }

    if( getParameter('filter') ){    
        if($oFilterForm->validateForm($_POST)) {
            // Exito, puedo procesar los datos ahora.
            $arrFilterExtraVars=array('filter_jail'=>$filter_Jail,'filter_ip'=>$filter_IP);
        } else {
            // Error
            $smarty->assign("mb_title", $arrLang["Validation Error"]);
            $arrErrores=$oFilterForm->arrErroresValidacion;
            $strErrorMsg = "<b>{$arrLang['The following fields contain errors']}:</b><br>";
            foreach($arrErrores as $k=>$v) {
                $strErrorMsg .= "$k, ";
            }
            $strErrorMsg .= "";
            $smarty->assign("mb_message", $strErrorMsg);
        }
        $htmlFilter = $oFilterForm->fetchForm("$local_templates_dir/filter.tpl", "", $_POST);
    } else if (isset($filter_Jail) || isset($filter_IP)) {
        $htmlFilter = $oFilterForm->fetchForm("$local_templates_dir/filter.tpl", "", $_GET);
       $arrFilterExtraVars=array('filter_jail'=>$filter_Jail,'filter_ip'=>$filter_IP);
    } else {
        $htmlFilter = $oFilterForm->fetchForm("$local_templates_dir/filter.tpl", "", $_POST);
    } 

    if (file_exists($lic_file)) 
        $smarty->assign("lic_status", $arrLang["Uploaded"]);
    else 
        $smarty->assign("lic_status", $arrLang["Not Uploaded"]);
    
    if(empty($arrValues)) $arrValues=$paloFail2Ban->loadSettings();
	
    if(isset($arrValues['asterisksecure']))
        ($arrValues['asterisksecure']=='on' ? $smarty->assign("asteriskchecked", "checked") : '');
    if(isset($arrValues['websecure']))
	($arrValues['websecure']=='on' ? $smarty->assign("webchecked", "checked") : '');
    if(isset($arrValues['sshsecure']))
	($arrValues['sshsecure']=='on' ? $smarty->assign("sshchecked", "checked") : '');
    if(isset($arrValues['vsftpdsecure']))
	($arrValues['vsftpdsecure']=='on' ? $smarty->assign("vsftpdchecked", "checked") : '');
    
    if($paloFail2Ban->getStatusServiceFail2Ban()=="active") { 
	   $smarty->assign("SERVICE_STARING", true);
	   $smarty->assign("Status_fail2ban", "<b><font color='#00AA00'>".$arrLang["Active"]."</font></b>");
    }
    else {
	   $smarty->assign("SERVICE_STARING", false);
	   $smarty->assign("Status_fail2ban", "<b><font color='#FF0000'>".$arrLang["Inactive"]."</font></b>");
    }


    //Check Installation package Fail2Ban
    if(!$paloFail2Ban->checkInstall('fail2ban'))
    {
	$smarty->assign("mb_title", $arrLang["Installation Error"]);
        $smarty->assign("mb_message", $arrLang["Fail2Ban Not Installed"]);
    }


    $smarty->assign("REQUIRED_FIELD", $arrLang["Required field"]);
    $smarty->assign("RUN", $arrLang["Update"]);
    $smarty->assign("SERVICE_START", $arrLang["Service Start"]);
    $smarty->assign("SERVICE_STOP", $arrLang["Service Stop"]);
    $smarty->assign("DELETE", $arrLang["Delete"]);
    $smarty->assign("Status", $arrLang["Status"]);
    $smarty->assign("SECUREWEB",$arrLang["Secure web"]);
    $smarty->assign("SECUREASTERISK",$arrLang["Secure asterisk"]);
    $smarty->assign("SECURESSH",$arrLang["Secure ssh"]);
    $smarty->assign("SECUREPROFTPD",$arrLang["Secure proftpd"]);
    $smarty->assign("SECUREVSFTPD",$arrLang["Secure vsftpd"]);
    $smarty->assign("SECURITY", $arrLang["Improved security"]);
    $smarty->assign("TURN_ON", $arrLang["Turn on"]);
    $smarty->assign("SECURITY", $arrLang["Security settings"]);
    $smarty->assign("BLOCKED", $arrLang["Blocked IP addresses"]);

    $smarty->assign("module_name",$module_name);

    $arrData=$paloFail2Ban->load_fail2ban_table($filter_Jail,$filter_IP);
    
    $total = count($arrData);
    
    $oGrid = new paloSantoGrid($smarty); 
 
    $action = getParameter("nav");
    $start  = getParameter("start");

    $url = array('menu' => $module_name); 
    if(isset($arrFilterExtraVars) && is_array($arrFilterExtraVars) and count($arrFilterExtraVars)>0) {
       $url = array_merge($url, $arrFilterExtraVars); 
    }

    

    if($oGrid->isExportAction()){
        $limit = $total;
        $offset = 0;
        $arrColumns = array(_tr("IP-address"), _tr("Attacked Service"));
      
        $oGrid->setColumns($arrColumns);
        $size = count($arrData);
        if(is_array($arrData) && $total>0)
        {
            foreach ($arrData as $key=>$val) 
                $tmpArrData[$key]=array($val[1],$val[2]); 
            $arrTableData=$oGrid->setData($tmpArrData);
        }
        
        return $oGrid->fetchGrid();
    }  
    else
    {  
        $limit = 15;
        $oGrid->setLimit($limit);
    	$oGrid->setTotal($total);
       
    	$offset = $oGrid->calculateOffset();
    	$end    = ($offset+$limit)<=$total ? $offset+$limit : $total;
    	
        $arrTableData=array_slice($arrData, $offset, $limit);
	
    }
    
    $arrGrid = array("title"    => $arrLang["Blocked IP addresses"],
                     "icon"     => "images/anti_hacker_logo.png",
                     "width"    => "99%",
                     "start"    => ($total==0) ? 0 : $offset+1,
                     "end"      => $end,
                     "url"      => $url,
                     "total"    => $total,
                     "columns"  => array(0 => array("name"  => "",
                                                    "property"  => ""),
                                         1 => array("name"  => $arrLang["IP-address"],
                                                    "property"  => "width=25%"),
                                         2 => array("name"  => $arrLang["Table"],
                                                    "property"  => "width=20%"),
    ));

    if(method_exists($oGrid,'deleteList'))
        $oGrid->deleteList(_tr("Are you sure you wish to delete IP from blocked list?"),"submit_eliminar",_tr("Delete")); 
    //BEGIN Filter Form
    if(method_exists($oGrid,'showFilter'))
	$oGrid->showFilter($htmlFilter);    
    if(method_exists($oGrid,'addFilterControl'))
    {
	if(isset($arrFilterExtraVars['filter_ip']))
	    $oGrid->addFilterControl('Filter applied: IP-address = '.$arrFilterExtraVars['filter_ip'],$arrFilterExtraVars['filter_ip'],array('filter_ip'=>''),false);
	if(isset($arrFilterExtraVars['filter_jail']))
	    $oGrid->addFilterControl('Filter applied: Attacked Service = '.$arrFilterExtraVars['filter_jail'],$arrFilterExtraVars,array('filter_jail'=>''),false);
    }
    //END Filter Form
    $oGrid->enableExport();   // enable export.
    //$oGrid->setNameFile_Export(_tr("BlockedIP"));

    $htmlGrid = $oGrid->fetchGrid($arrGrid, $arrTableData, $arrLang);
    $smarty->assign("IPTABLE",$htmlGrid);
    $smarty->assign("icon",'modules/anti_hacker/images/anti_hacker_logo.png');
    $strReturn = $oForm->fetchForm("$local_templates_dir/anti_hacker.tpl", $arrLang["Security settings"], $arrValues);
    
    return $strReturn;    
}

function createFilterForm($arrLang)
{
    $arrJails = array(''=>'','asterisk'=>'asterisk','https'=>'https','ssh'=>'ssh','vsftpd'=>'vsftpd');
    
    $arrayFields = array(
        "filter_ip"   => array( "LABEL"			 => $arrLang["IP-address"],
                                "REQUIRED"      	 => "no",
                                "INPUT_TYPE"    	 => "TEXT",
                                "VALIDATION_TYPE"        => "ip",
				                "INPUT_EXTRA_PARAM"	 => "",
                                "VALIDATION_EXTRA_PARAM" => ""),
                         
        "filter_jail" => array( "LABEL"                  => $arrLang["Table"],
                                "REQUIRED"               => "no",
                                "INPUT_TYPE"             => "SELECT",
                                "INPUT_EXTRA_PARAM"      => $arrJails,
                                "VALIDATION_TYPE"        => "",
                                "VALIDATION_EXTRA_PARAM" => ""),
    );
    return $arrayFields;
}
?>
